/*
    AGGRESSIVE PONG.
    Copyright (C) 2010  Eugene Popov (popov_e_n@mail.ru)

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>
*/

#include "../lib/input_module.inc.prg"
#include "../lib/menu.inc.prg"
#include "../lib/wm_utils.inc.prg"
#include "../lib/text.inc.prg"

// key name
global
  string ck_name[] = (
    "Null", // Нулябрь, ага     0
    "Move up",//1
    "Move down",//2
    "Move left",//3
    "Move right",//4
    "Pause / Menu",//5
    "Use item / Activate menu",//6
    "Use defence / Activate menu",//7
    "Turbo motion",//8
    "Use Ball Effect",//9
    "Sound volume up",//10
    "Sound volume down",//11
    ""
  );
  
end

/*----------------------------------------------*/

process init_controls()
local
  int dev, k, ev, tick;
  bool f;
end
begin
  say('Init controls...');
  
  graph = text_to_map( 0, "Press a key" );
  x = 160 - graphic_info( file, graph, G_WIDTH)/2;
  y = 120;
  
  /// ck_p1 and ck_p2 now not used how it was planned originally.
  ck_p1[ CK_UP ]    = _JKEY_UP;
  ck_p1[ CK_DOWN ]  = _JKEY_DOWN;
  ck_p1[ CK_LEFT ]  = _JKEY_LEFT;
  ck_p1[ CK_RIGHT ] = _JKEY_RIGHT;
  ck_p1[ CK_MENU ]  = _JKEY_MENU;
  ck_p1[ CK_ACT_I ] = _JKEY_A;
  ck_p1[ CK_ACT_D ] = _JKEY_B;
  ck_p1[ CK_TURBO ] = _JKEY_X;
  ck_p1[ CK_EFFECT ]= _JKEY_Y;
  ck_p1[ CK_VOLUP ] = _JKEY_VOLUP;
  ck_p1[ CK_VOLDN ] = _JKEY_VOLDOWN;
  
  ck_p2[ CK_UP ]    = _JKEY_UP;
  ck_p2[ CK_DOWN ]  = _JKEY_DOWN;
  ck_p2[ CK_LEFT ]  = _JKEY_LEFT;
  ck_p2[ CK_RIGHT ] = _JKEY_RIGHT;
  ck_p2[ CK_MENU ]  = _JKEY_MENU;
  ck_p2[ CK_ACT_I ] = _JKEY_A;
  ck_p2[ CK_ACT_D ] = _JKEY_B;
  ck_p2[ CK_TURBO ] = _JKEY_X;
  ck_p2[ CK_EFFECT ]= _JKEY_Y;
  ck_p2[ CK_VOLUP ] = _JKEY_VOLUP;
  ck_p2[ CK_VOLDN ] = _JKEY_VOLDOWN;
  
  // waiting for any key on any device
  // to enshure this device is alive...
  f = true;
  tick = 0;
  while( f )
    tick++;
    if( tick > 10 )
	if( alpha==0 ) alpha=1000; else alpha=0; end
	tick = 0;
    end;
    frame;
    for( k=0; input_dev_name(k)!=""; k++ )
//      say( input_dev_name(k) );
      if( __im_get_iev(k) )
	while( __im_get_iev(k) ); frame; end;
	p1_input = k;
	f =false;
	break;
      end
    end
  end;
      
  if( os_handheld )
    // always use joy 1 on GPH
    
    input_set_dev( 0 );
    input_preset_safe();
  
    p1_input = 1;
    p2_input = 0;
  
    input_set_dev(p1_input);
    input_preset_gph();
    
    if( input_dev_name(2)!="")
      // if second joy is sttached
      p2_input = 2;
      input_set_dev(2);
      input_preset_safe();
      input_load_config(p1_devconfig);
      
      if( input_dev_name(p2_input) == "" || !input_is_sane() )
	say("P2 input is misconfigured - fallback");
	p2_input = 0;
	input_set_dev( p2_input );
	input_preset_safe();
      end;
    end
    
  else
    // use config files
    input_set_dev( 0 );
    input_set_dev( p1_input );
    input_preset_safe();
    input_load_config( p1_devconfig );
    input_set_dev( p2_input );
    input_preset_safe();
    input_load_config( p2_devconfig );
  
    /// ensure we have contol
    //input_dev_name(p1_input);
    if( input_dev_name(p1_input) == "" || !input_is_sane() )
      say("P1 input is misconfigured - fallback");
      p1_input = 0;
      input_set_dev( p1_input );
      input_preset_safe();
    end;
    //input_dev_name(p2_input);
    if( input_dev_name(p2_input) == "" || !input_is_sane() )
      say("P2 input is misconfigured - fallback");
      p2_input = 0;
      input_set_dev( p2_input );
      input_preset_safe();
    end;
    
  end;
  
//  __input_dev_dump(p1_input);
//  __input_dev_dump(p2_input);
  unload_map( file, graph );
end

/*----------------------------------------------*/
process configure_control( int *pctls, string title )
local
  wm_window wnd;
  stringlist lst;
  menu_selectbox box;
  int i, t1, t2, t3;
end
begin
  list_create( &lst );
  for(i = 1 ; i< CK_COUNT ; i++ )
  end
  list_grow( &lst, " Back to menu " );       // 6
  
  box = menu_selectbox( lst, 10 );
  wnd = wm_window( box, WM_W_SELFPLACED | WM_W_TOOLBAR | WM_W_SOFTAPPEAR );
  wnd.title = title ;  
  frame;
  wnd.x = ( scr_width()  - wnd.ww ) /2;
  wnd.y = ( scr_height() - wnd.wh ) /2;
  wnd.z = wm_z_act-1;  
  
  loop
    input_allow(box);
    frame;
    
    if( jkey( _JKEY_A ) || jkey( _JKEY_B ) )
      while( jkey( _JKEY_A ) || jkey( _JKEY_B ) ) frame; end;

      switch( (os_handheld && box.selected > 2) ? box.selected+1 : box.selected )
	case 0 :
	  return;
	end
      end
    end
    
  end
end

/*-----------------------------------------------------*/

process gm_input_bind_menu( int player_num )
local
  wm_window wnd;
  stringlist lst;
  menu_selectbox box;
  wmu_jkey_assigner ka;
  int new_assigns[CK_COUNT];
  int i, j, k, ev, reading_dev;
  int n=0;
  bool okf;
end
begin

  list_create( &lst );
  list_grow( &lst, " Back " );
  list_grow( &lst, " Configure keys ");
    
  box = menu_selectbox( lst, CK_COUNT );
  wnd = wm_window( box,  WM_W_SELFPLACED | WM_W_UNREGISTRED  );
  wnd.title  = "Keys";
  frame;
  wnd.z = wm_z_act-4;
  wnd.x = ( scr_width()  - wnd.ww ) /2;
  wnd.y = ( scr_height() - wnd.wh ) /2;
  
  input_allow( box );
  frame;
  loop
    if( jkey( _JKEY_A ) || jkey( _JKEY_B ) )
      while( jkey( _JKEY_A ) || jkey( _JKEY_B ) ) frame; end;
      if( box.selected == 0 ) return; end
      break;
    end
    
    frame;
  end
  
  say('Configure!');
  input_allow(box);
  frame;
  n=0;
  for( i=1; ck_name[i] != "" ; i++ ) 
    n++;
  end;
  
  signal(wnd, S_KILL);
  list_free( &lst );
  frame;
  list_create( &lst );
  for( i=1; ck_name[i] != "" ; i++ ) 
    list_grow( &lst, " "+ck_name[i]/*+" = "+ck_p1[i]*/ );
  end
  box = menu_selectbox( lst, CK_COUNT );
  wnd = wm_window( box,  WM_W_SELFPLACED | WM_W_UNREGISTRED | WM_W_TOOLBAR);
  wnd.title  = "Strike a key";
  frame;
  wnd.z = wm_z_act-4;
  wnd.x = ( scr_width()  - wnd.ww ) /2;
  wnd.y = ( scr_height() - wnd.wh ) /2;
  
  for( j=1; j<=n; j++ )
    new_assigns[j] = 0;
  end
  
  /// Loop thru binds
  reading_dev = -1;
  for( j=1; j<=n; j++ )
    say('KC='+ck_name[j]);
    wnd.bottom  = input_dev_name(reading_dev);
  
    list_free( &lst );
    list_create( &lst );
    for( i=1; ck_name[i] != "" ; i++ ) 
      list_grow( &lst, " "+ck_name[i]/*+" = "+ck_p1[i] */);
    end
    box.redraw = 1;
    box.selected = j-1;
    
    if(reading_dev == -1)
      // choose device by the first keypress
      okf = false;
      repeat
	for( k=0; input_dev_name(k)!=""; k++ )
	  frame;
	  if( ev = __im_get_iev( k ) )
	    while(ev == __im_get_iev( k )) frame; end;
	    say("First strike: "+k);
	    reading_dev = k;
	    okf = true;
	    break;
	  end;
	end;
      until( okf );
    else
      ev = 0;
    end;
    
    //okf = false;
    loop
    
      while( !ev )
	ev = __im_get_iev( reading_dev );
	frame;
      end    
      while(ev == __im_get_iev( reading_dev )) frame; end;
      
      say(reading_dev+"/"+ev);
      //chack if already assigned...
      for(k=0;k<j;k++)
	if(new_assigns[k]==ev)
	  say('Already defined!');
	  break;
	end
      end
      
      if(k==j) 
	new_assigns[j] = ev;
	break;
      end
      
    end;
    
  end;
  
  for(i=1; i<=n; i++ )
    __im_assign_jkey2event ( reading_dev, ck_p1[i] , new_assigns[i] );
    say('ASSIGN: '+ck_p1[i]+'='+new_assigns[i]);
  end;
  
  if( player_num == 1 )
    p1_input = reading_dev;
  else
    p2_input = reading_dev;
  end;
  
onexit
  input_set_dev( p1_input );
  input_save_config( p1_devconfig );
  input_set_dev( p2_input );
  input_save_config( p2_devconfig );    
  save_options( options_file );
  signal(wnd, S_KILL);
  list_free( lst );
  input_set_dev( p1_input );  
  
end

/*-----------------------------------------------------*/

