/*
    AGGRESSIVE PONG.
    Copyright (C) 2010  Eugene Popov (popov_e_n@mail.ru)

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>
*/

/*----------------------------------------------------------------------*/

function tune_ai_level_0( ai_tunable_loop ai )
begin
  ai.opt_prize_catcher = 0;
  ai.opt_deflector = 0; // uses shield
  ai.opt_agressive = 0; // uses items
  ai.opt_surprizer = 0; // uses effects
  ai.opt_speedy    = 0; // uses speedup
  ai.opt_sauron    = 0; // sees invisible ball
  ai.opt_mascot_summoner  = 0;
  ai.opt_prediction_level = 0; // number of ball reflections to apprise
end

/*----------------------------------------------------------------------*/

function tune_ai_level_noob( ai_tunable_loop ai )
begin
  ai.opt_prize_catcher = 1;
  ai.opt_deflector = 0; // uses shield
  ai.opt_agressive = 0; // uses items
  ai.opt_surprizer = 0; // uses effects
  ai.opt_speedy    = 1; // uses speedup
  ai.opt_sauron    = 0; // sees invisible ball
  ai.opt_mascot_summoner  = 0;
  ai.opt_prediction_level = 0; // number of ball reflections to apprise
end

/*----------------------------------------------------------------------*/

function tune_ai_level_ponger( ai_tunable_loop ai )
begin
  ai.opt_prize_catcher = 1;
  ai.opt_deflector = 0; // uses shield
  ai.opt_agressive = 0; // uses items
  ai.opt_surprizer = 0; // uses effects
  ai.opt_speedy    = 1; // uses speedup
  ai.opt_sauron    = 0; // sees invisible ball
  ai.opt_mascot_summoner  = 0;
  ai.opt_prediction_level = 2; // number of ball reflections to apprise
end

/*----------------------------------------------------------------------*/

function tune_ai_level_shielder( ai_tunable_loop ai )
begin
  ai.opt_prize_catcher = 1;
  ai.opt_deflector = 1; // uses shield
  ai.opt_agressive = 0; // uses items
  ai.opt_surprizer = 0; // uses effects
  ai.opt_speedy    = 1; // uses speedup
  ai.opt_sauron    = 0; // sees invisible ball
  ai.opt_mascot_summoner  = 0;
  ai.opt_prediction_level = 2; // number of ball reflections to apprise
end

/*----------------------------------------------------------------------*/

function tune_ai_level_shotter( ai_tunable_loop ai )
begin
  ai.opt_prize_catcher = 1;
  ai.opt_deflector = 0; // uses shield
  ai.opt_agressive = 1; // uses items
  ai.opt_surprizer = 0; // uses effects
  ai.opt_speedy    = 1; // uses speedup
  ai.opt_sauron    = 0; // sees invisible ball
  ai.opt_mascot_summoner  = 1;
  ai.opt_prediction_level = 2; // number of ball reflections to apprise
end

/*----------------------------------------------------------------------*/

function tune_ai_level_surprizer( ai_tunable_loop ai )
begin
  ai.opt_prize_catcher = 1;
  ai.opt_deflector = 0; // uses shield
  ai.opt_agressive = 0; // uses items
  ai.opt_surprizer = 1; // uses effects
  ai.opt_speedy    = 1; // uses speedup
  ai.opt_sauron    = 0; // sees invisible ball
  ai.opt_mascot_summoner  = 1;
  ai.opt_prediction_level = 2; // number of ball reflections to apprise
end


/*----------------------------------------------------------------------*/

function tune_ai_level_agressor( ai_tunable_loop ai )
begin
  ai.opt_prize_catcher = 1;
  ai.opt_deflector = 0; // uses shield
  ai.opt_agressive = 1; // uses items
  ai.opt_surprizer = 1; // uses effects
  ai.opt_speedy    = 1; // uses speedup
  ai.opt_sauron    = 0; // sees invisible ball
  ai.opt_mascot_summoner  = 1;
  ai.opt_prediction_level = 3; // number of ball reflections to apprise
end

/*----------------------------------------------------------------------*/

function tune_ai_level_exelent( ai_tunable_loop ai )
begin
  ai.opt_prize_catcher = 1;
  ai.opt_deflector = 1; // uses shield
  ai.opt_agressive = 1; // uses items
  ai.opt_surprizer = 1; // uses effects
  ai.opt_speedy    = 1; // uses speedup
  ai.opt_sauron    = 0; // sees invisible ball
  ai.opt_mascot_summoner  = 1;
  ai.opt_prediction_level = 4; // number of ball reflections to apprise
end

/*----------------------------------------------------------------------*/

function tune_ai_level_last( ai_tunable_loop ai )
begin
  ai.opt_prize_catcher = 1;
  ai.opt_deflector = 1; // uses shield
  ai.opt_agressive = 1; // uses items
  ai.opt_surprizer = 1; // uses effects
  ai.opt_speedy    = 1; // uses speedup
  ai.opt_sauron    = 1; // sees invisible ball
  ai.opt_prediction_level = 5; // number of ball reflections to apprise
end

/*----------------------------------------------------------------------*/

process gamestory( int fromlevel)
local
  int i, state_initial;
  ai_tunable_loop ai;
end
begin
  state_initial = state_unlocked;
  
  if( fromlevel <= 1 )
    i = intermission('../data/lvl-1.png');
    while( exists(i) ) frame; end;  
    ai = ai_tunable_loop( 0, 0, 0 );
    i = level( 0, 1, 0, ai );
    tune_ai_level_0( ai );
    while( exists(i) ) frame; end;  
    if( level_winner_side == 1 ) return; end
    if( state_unlocked < 2 ) state_unlocked = 2; end;
  end
  
  if( fromlevel <= 2 )
    i = intermission('../data/lvl-2.png');
    while( exists(i) ) frame; end;  
    ai = ai_tunable_loop( 0, 0, 0 );
    i = level( 0, 1, 0, ai );
    tune_ai_level_noob( ai );
    while( exists(i) ) frame; end;  
    if( level_winner_side == 1 ) return; end
    if( state_unlocked < 3 ) state_unlocked = 3; end;
  end
  
  if( fromlevel <= 3 )
    i = intermission('../data/lvl-3.png');
    while( exists(i) ) frame; end;  
    ai = ai_tunable_loop( 0, 0, 0 );
    i = level( 0, 1, 0, ai );
    tune_ai_level_ponger( ai );
    while( exists(i) ) frame; end;  
    if( level_winner_side == 3 ) return; end
    if( state_unlocked < 4 ) state_unlocked = 4; end;
  end
  
  if( fromlevel <= 4 )
    i = intermission('../data/lvl-4.png');
    while( exists(i) ) frame; end;  
    ai = ai_tunable_loop( 0, 0, 0 );
    i = level( 0, 1, 0, ai );
    tune_ai_level_shielder( ai );
    while( exists(i) ) frame; end;  
    if( level_winner_side == 1 ) return; end
    if( state_unlocked < 5 ) state_unlocked = 5; end;
  end
  
  if( fromlevel <= 5 )
    i = intermission('../data/lvl-5.png');
    while( exists(i) ) frame; end;  
    ai = ai_tunable_loop( 0, 0, 0 );
    i = level( 0, 1, 0, ai );
    tune_ai_level_shotter( ai );
    while( exists(i) ) frame; end;  
    if( level_winner_side == 1 ) return; end
    if( state_unlocked < 6 ) state_unlocked = 6; end;
  end
  
  if( fromlevel <= 6 )
    i = intermission('../data/lvl-6.png');
    while( exists(i) ) frame; end;  
    ai = ai_tunable_loop( 0, 0, 0 );
    i = level( 0, 1, 0, ai );
    tune_ai_level_surprizer( ai );
    while( exists(i) ) frame; end;  
    if( level_winner_side == 1 ) return; end
    if( state_unlocked < 7 ) state_unlocked = 7; end;
  end
  
  if( fromlevel <= 7 )
    i = intermission('../data/lvl-7.png');
    while( exists(i) ) frame; end;  
    ai = ai_tunable_loop( 0, 0, 0 );
    i = level( 0, 1, 0, ai );
    tune_ai_level_agressor( ai );
    while( exists(i) ) frame; end;
    if( level_winner_side == 1 ) return; end
    if( state_unlocked < 8 ) state_unlocked = 8; end;
  end
  
  if( fromlevel <= 8 )
    i = intermission('../data/lvl-8.png');
    while( exists(i) ) frame; end;  
    ai = ai_tunable_loop( 0, 0, 0 );
    i = level( 0, 1, 0, ai );
    tune_ai_level_exelent( ai );
    while( exists(i) ) frame; end;
    if( level_winner_side == 1 ) return; end
    if( state_unlocked < 9 ) state_unlocked = 9; end;
  end
  
  if( fromlevel <= 9 )
    i = intermission('../data/lvl-9.png');
    while( exists(i) ) frame; end;  
    ai = ai_tunable_loop( 0, 0, 0 );
    i = level( 0, 1, 0, ai );
    tune_ai_level_last( ai );
    while( exists(i) ) frame; end;
    if( level_winner_side == 1 ) return; end
    if( state_unlocked < 10 ) state_unlocked = 10; end;
  end

i = final_animation();
  while( exists(i) ) frame; end;  
  
onexit
 if( state_unlocked > state_initial ) save_state( state_file ); end
 signal( i, S_KILL );  
end
