/*
    AGGRESSIVE PONG.
    Copyright (C) 2010  Eugene Popov (popov_e_n@mail.ru)

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>
*/

#include "../lib/wm.inc.prg"

import "mod_math"

#define PLAYER_MAX_ITEMS 30
#define PLAYER_MAX_MANA gam_max_mana

#define PL_I_SURIKEN 1 
#define PL_I_AXE     2
#define PL_I_WALL    3
#define PL_I_MANA    4 
#define PL_I_BROCKET 5
#define PL_I_BINVIS  6
#define PL_I_WIDE    7

#define PL_I_HEAVY    51
#define PL_I_EQUALIZE 52
#define PL_I_STOPBALL 53

#define PL_I_DAMAGE   101
#define PL_I_NROCKET  102

#include "itemregistry.inc.prg"

/*--------------------------------------------------------*/

global
  int victum = 0;
end

/*--------------------------------------------------------*/

// dir == side <-- 0 --- 1 -->
declare process player( int dir, int ai, int inputdev )
public
  int left_balls = 3; // score = lives
  int mascot_points = 4; // superior left before summon
  int item [PLAYER_MAX_ITEMS]; // items in stack
  int itemcnt = 0;
  int mana = 0; /// used for speedup & defence
  int effect_ghost = 0; // a ghost mode after sudden death
  int effect_pain  = 0;
  int effect_wide  = 0;
  int effect_heavy = 0;
  
  int charge_invisible  = 0;
  int charge_rocketball = 0;
  
  int p_cmd = 0;
  int action_thres = 0;
  int spd = 0;
  int charged = 0;
  
  shield mysh = 0;
  turboflame fl0, fl1;
  emarker effi, effr;
  int side, do_charge, do_uncharge;
end
end

/*--------------------------------------------------------*/

declare process item(int itype, int x, int y)
local
  int dx;
  player plx ,plx2;
  ball bl;
  int dual;
  int negative;
  int i, k, typ;
  int eqitems[PLAYER_MAX_ITEMS*2];
end
end

/*--------------------------------------------------------*/

declare process gmarker( int x, int y, int dir )
local
  ani_loop lp;
  int tick;
end
end

/*--------------------------------------------------------*/

declare process emarker( int typ, int selfid, int dir )
local
  ani_loop lp;
  player pl;
end
end

/*--------------------------------------------------------*/

declare process sectionmarker( int anchor, int max )
public
  int param = 0;
local
  int k;
  ani_loop lp;
end
end

/*--------------------------------------------------------*/

declare process ball()
local
  int xangle; // fly direction, do not use angle because we do not wat to rotate glyph
  int thres, wthres;
  player refl;
  int adv;
  int invis;
  ani_loop lp;
  int ingame;
  int stopped;
  sectionmarker mark;
end  
end

/*--------------------------------------------------------*/

declare process spark( int graph, int source_proc )
local
  int vx;
  int vy;
end  
end

/*--------------------------------------------------------*/

declare process suriken( selfid, x, y )
local
  player pl;
  int vx,vy, tick, blthres;
  int dangerous;
  suriken su;
  ball bl;
end
end

/*--------------------------------------------------------*/

declare process axe( selfid, x, y )
local
  player pl;
  int vx,vy, tick;
  int dangerous;
  suriken su;
end
end

/*--------------------------------------------------------*/

declare process wall( selfid, x, y )
local
  player pl;
  int vx,vy, tick;
  int dangerous;
  suriken su;
end
end

/*--------------------------------------------------------*/

declare process shield( selfid )
local
  player pl;
  int vx,vy, tick;
  ani_loop lp;
  suriken su;
  axe ax;
end
end

/*-------------------------------------------------------*/

declare process turboflame( int selfid, int dir )
local
  player pl;
  ani_loop lp1;
  ani_loop lp2;
  int t1, t2;
end
end


/*-------------------------------------------------------*/

process player(int dir ,int ai, int inputdev)
begin
  z = wm_z_inact;
  side = dir;
  
  left_balls = gam_max_balls;
  mascot_points = gam_summon_hits;
  
  if( dir )
    flags = B_HMIRROR;
    x = scr_width() -15 ;
    y = scr_midy();
  else
    x = 14 ;
    y = scr_midy();
  end;
  
  fl0 = turboflame( id, 0 );
  fl1 = turboflame( id, 1 );
  
  effi = emarker( 0, id, dir );
  effr = emarker( 1, id, dir );
  
  do_charge = do_uncharge = 0;
  
  loop
    p_cmd = 0;
    graph = effect_wide>0 ? img_platformw : img_platform;
    graph = effect_heavy>0 ? img_platformh : graph;
    
    frame;

    if( ai )
      // ai refresh
    else
      if( jdkey( _JKEY_UP,   inputdev ) ) p_cmd |= PCMD_UP; end
      if( jdkey( _JKEY_DOWN, inputdev ) ) p_cmd |= PCMD_DOWN; end
      if( jdkey( _JKEY_A,    inputdev ) ) p_cmd |= PCMD_ITEM; end
      if( jdkey( _JKEY_B,    inputdev ) ) p_cmd |= PCMD_DEFENCE; end
      if( jdkey( _JKEY_X,    inputdev ) ) p_cmd |= PCMD_SPEEDUP; end
      if( jdkey( _JKEY_Y,    inputdev ) ) p_cmd |= PCMD_CHARGE; end
    end
    
    if( action_thres>0 ) action_thres--; end
    if( effect_wide>0 )  effect_wide--; end
      
    if( effect_ghost>0 ) 
      effect_ghost -- ;
      alpha = effect_ghost %3 ? 50 : 127;
    else
      alpha = 255;
    end
    
    if( ! exists(mysh) ) mysh = 0; end
    
    if( effect_heavy>0 )
      effect_heavy--;
    end;
    
    if( effect_pain>0 )
      
      effect_pain --;
      if( option_blood_on )
	//spark( img_blood, id );
	spark( img_blood, id );
      end
      
    else
	
      spd = effect_heavy || ( p_cmd & PCMD_SPEEDUP );
    
      if( (p_cmd & PCMD_CHARGE) && ( charge_invisible || charge_rocketball ) )
	if( !charged && do_uncharge==0 ) do_charge = 1; end;
	if(  charged && do_charge==0 ) do_uncharge = 1; end;
      else
	do_charge = do_uncharge = 0;
      end
    
      if( !charged && do_charge )
	charged = 1;
      end;
    
      if( charged && do_uncharge )
	charged = 0;
      end;
    
      if( !charge_invisible && !charge_rocketball )
	charged = 0;
      end;

      if( p_cmd & PCMD_ITEM  && (action_thres<=0) && itemcnt>0 && !mysh )
	action_thres = effect_heavy ? gam_fps/2 : gam_fps*3;
	itemcnt--;
	if(item[itemcnt] == PL_I_SURIKEN ) suriken( id, x, y ); end;
	if(item[itemcnt] == PL_I_AXE )	   axe( id, x, y ); end;
	if(item[itemcnt] == PL_I_WALL )    wall( id, x, y ); end;
      end

      if( !effect_heavy && (p_cmd & PCMD_DEFENCE)  && mana>=10 && ( mysh==0 ) && effect_ghost<=0 )
	action_thres = gam_fps*3;
	mysh = shield( id );
	mana -= 10;
      end

      if( y>0 &&  ( p_cmd & PCMD_UP )  ) 
	if( mana>0 && spd )
	  mana --;
	  y -= effect_heavy ? gam_platform_spd : gam_platform_boost;
	else
	  y -= effect_heavy ? gam_platform_spdslow : gam_platform_spd;
	end
      end;
      
      if( y< scr_height() && ( p_cmd & PCMD_DOWN ) )
	if( mana>0 && spd )
	  mana --;
	  y += effect_heavy ? gam_platform_spd : gam_platform_boost;
	else
	  y += effect_heavy ? gam_platform_spdslow  : gam_platform_spd;
	end
      end;
      
    end
  end;
end;

/*-------------------------------------------------------*/

process item( int itype, int x, int y )
begin
  z = wm_z_inact;
  dx = ( x > scr_midx() ) ? -1 : +1;
  
  prize_reg( id, dx<0 );
  
  typ      = itype;
  negative = 0;
  dual     = 0;
  
  switch( itype )
    case PL_I_SURIKEN:
      graph = img_ico_suriken;
    end  
    case PL_I_WALL:
      graph = img_ico_wall;
    end  
    case PL_I_AXE:
      graph = img_ico_axe;
    end  
    case PL_I_MANA:
      graph = img_mana;
    end  
    case PL_I_BINVIS:
      graph = img_ico_invis;
    end  
    case PL_I_BROCKET:
      graph = img_ico_rocket;
    end  
    case PL_I_WIDE:
      graph = img_ico_wide;
    end  
    case PL_I_STOPBALL:
      graph = img_ico_stopball;
      dual = 1;
    end  
    case PL_I_EQUALIZE:
      graph = img_ico_equalize;
      dual = 1;
    end  
    case PL_I_HEAVY:
      graph = img_ico_heavy;
      dual = 1;
    end  
    case PL_I_DAMAGE:
      graph = img_ico_damage;
      negative = 1;
    end  
    case PL_I_NROCKET:
      graph = img_ico_neg_rocket;
      negative = 1;
    end  
  end

  loop
    x += dx;
    if( x<=0 || x >= scr_width() )
      //angle = 180000 - angle;
      break;
    end;

    if( plx = collision(type player) )
      if( plx.effect_ghost == 0 )
	switch( itype )
	  case PL_I_MANA:
	    plx.mana += 50; 
	    if(plx.mana > PLAYER_MAX_MANA ) plx.mana = PLAYER_MAX_MANA; end
	  end  
	  case PL_I_BINVIS:
	    plx.charge_invisible = 1; 
	  end  
	  case PL_I_BROCKET:
	    plx.charge_rocketball = 1; 
	  end  
	  case PL_I_SURIKEN:
	    if(plx.itemcnt < PLAYER_MAX_ITEMS) plx.item[plx.itemcnt++] = PL_I_SURIKEN; end
	    if(plx.itemcnt < PLAYER_MAX_ITEMS) plx.item[plx.itemcnt++] = PL_I_SURIKEN; end
	    if(plx.itemcnt < PLAYER_MAX_ITEMS) plx.item[plx.itemcnt++] = PL_I_SURIKEN; end
	    if(plx.itemcnt < PLAYER_MAX_ITEMS) plx.item[plx.itemcnt++] = PL_I_SURIKEN; end
	  end  
	  case PL_I_WALL:
	    if(plx.itemcnt < PLAYER_MAX_ITEMS) plx.item[plx.itemcnt++] = PL_I_WALL; end
	  end  
	  case PL_I_AXE:
	    if(plx.itemcnt < PLAYER_MAX_ITEMS) plx.item[plx.itemcnt++] = PL_I_AXE; end
	  end  
	  case PL_I_WIDE:
	    plx.effect_wide = gam_fps*10;
	  end  
	  case PL_I_HEAVY:
	    plx.effect_heavy = gam_fps*100;
	  end  
	  case PL_I_DAMAGE:
	    plx.effect_pain  = gam_blood_frames / 2;
	    plx.effect_ghost = gam_ghost_frames / 2;
	  end  
	  case PL_I_NROCKET:
	    bl = get_id(type ball);
	    if( exists(bl) ) bl.adv = gam_ball_boost; end
	  end  
	  case PL_I_STOPBALL:
	    bl = get_id(type ball);
	    if( exists(bl) ) bl.stopped = gam_ball_stop_time; end
	  end  
	  case PL_I_EQUALIZE:
	      plx2 = get_id(type player);
	      if(plx2 == plx)
		plx2 = get_id(type player);
	      end
	      if( exists(plx2) && plx2 != plx )
		// equalize status;
		plx2.mana = plx.mana = (plx2.mana + plx.mana)/2;
		plx2.charge_invisible  = plx.charge_invisible = plx2.charge_invisible | plx.charge_invisible;
		plx2.charge_rocketball = plx.charge_rocketball = plx2.charge_rocketball | plx.charge_rocketball;
		// equalize items: TODO
		k = 0;
		for( i=0; i<plx.itemcnt && k<PLAYER_MAX_ITEMS*2; i++)
		  eqitems[k++]=plx.item[i];
		end
		for( i=0; i<plx2.itemcnt && k<PLAYER_MAX_ITEMS*2; i++)
		  eqitems[k++]=plx2.item[i];
		end
		//eqitems[k]=-1;
		plx.itemcnt=0;
		plx2.itemcnt=0;
		for( i=0; i<k && i<PLAYER_MAX_ITEMS*2; i++)
		  if(i%2)
		    plx.item[plx.itemcnt++] = eqitems[i];
		  else
		    plx2.item[plx2.itemcnt++] = eqitems[i];
		  end
		end
		
	      end;
	  end  
	end
	break;
      end
    end;

    frame;   
  end;
end;

/*-------------------------------------------------------*/

process ball()
begin
  z = wm_z_inact;
  //graph = img_ball;
  ani_new_loop( &lp, &ani_ball);
  graph = ani_next_frame( &lp );
  
  xangle = 45000 + rand(0,3) * 90000;
    
  x = scr_midx();
  y = 0;
  
  adv = gam_ball_spd;
  invis = 0;
    
  ingame = 0;
  
  thres = gam_fps;
  while(thres >0)
    thres--; frame;
  end
  
  set_scroll(0, +1);
  
  while(y < scr_midy())
    y++; frame;
  end  
  
  ingame = 1;
  mark = 0;
  wthres = 0;
  adv = gam_ball_spd;
  stopped =0;
  
  loop
    graph = ani_next_frame( &lp );
    frame;
    
    if(stopped >0)
      if( ! mark ) mark = sectionmarker( id, gam_ball_stop_time ); end;
      mark.param = stopped--; frame;
    else
      if( exists(mark) ) signal ( mark, S_KILL ); end
      mark = 0;
    end  
    
    if( x<=0 || x >= scr_width() )
      victum = (x<=0) ? 0:1 ;
      //angle = 180000 - angle;
      gmarker( x>0? scr_width() -1 : 0, y, x>0 );
      break;
    end;

    if( wthres>0 ) wthres--; end
      
    if( !wthres && ( y<=0 || y >= scr_height() ) )
    // wall
      wthres = gam_fps;
      sfx_play( sfx_ribbon_collision );
      xangle = -xangle;
      set_scroll( cos(xangle)>0?1:-1, sin(xangle)>0?-1:1 );
    end;
    
    if( thres >0 ) thres--; end;
    if( invis && alpha>0 )  alpha-=5; end;

    if( thres==0 && ( refl = collision(type player) ) )
      if( refl.effect_ghost<=0 )
	sfx_play( sfx_ribbon_collision );
	alpha = 255;
	invis = 0;
	adv = gam_ball_spd;
      
	if( refl.charged )
	  if( refl.charge_invisible>0 ) refl.charge_invisible--; invis = 1; alpha = 127;
	  end;
	  
	  if( refl.charge_rocketball>0 ) refl.charge_rocketball--; adv = gam_ball_boost; 
	  end;
	end
		
	xangle = 180000 - xangle;
	thres = gam_fps/2;
	set_scroll(cos(xangle)>0?1:-1, sin(xangle)>0?-1:1);

	if( x > scr_midx() )
	  item( select_prize(), scr_width() * 3 / 4, y );
	else
	  item( select_prize(), scr_width() * 1 / 4, y );
	end

	spark( img_sparkle, id );
	spark( img_sparkle, id );
	spark( img_sparkle, id );
	spark( img_sparkle, id );
	spark( img_sparkle, id );
      end;
    end;
        
    if(!stopped)       
      xadvance( xangle, adv ); 
    end
      
  end;
onexit
    //alpha = 255;
    //fountain of death
//     thres = gam_fps * 3;
//     while( thres-- )
//       if( thres % 3 )
// 	//say(x+','+y);
// 	spark( img_sparkle, id );
//       end;
//       frame 300;
//     end;
end;

/*-------------------------------------------------------*/

process spark( int graph, int source_proc )
begin
  
  z = wm_z_inact;
  flags |= B_HMIRROR * rand(0,1);
  flags |= B_VMIRROR * rand(0,1);
  x = source_proc.x;
  y = source_proc.y;
  vx =  x > scr_midx() ? rand( -4, -1 ) : rand( 1, 4 );
  vy = rand( -40, 10 );
  if( x<0 ) x=0; end
  if( y<0 ) y=0; end
  if( x>scr_width() ) x=scr_width()-1; end
  if( y>scr_height() ) y=scr_height()-1; end
  while( ! out_region( id, 0 ) )
    frame;
    x  += vx;
    y  += vy/10;
    vy += 3;
  end
end
/*-------------------------------------------------------*/

process gmarker( int x, int y, int dir )
begin
  z = wm_z_act-2;
  
  flags = dir * B_HMIRROR;
  
  ani_new_loop( &lp, &ani_marker );
  
  tick = gam_scr_fps;
  while( tick-- )
    graph = ani_next_frame( &lp );
    frame 200;
  end
  
end
/*-------------------------------------------------------*/

process suriken( selfid, x, y )
begin
  sfx_play( sfx_metal_bell );
  z = wm_z_inact;
  graph = img_suriken;
  vx =  x > scr_midx() ? -gam_bullet_spd2: gam_bullet_spd2;
  bullet_reg( id, vx<0 );
  vy = 0;
  dangerous = 1;
  blthres = 0;
  while( ! out_region( id, 0 ) && dangerous )
    
    angle += 10000;
    x  += vx;
    y  += vy;
    if( su = collision( type suriken ) )
      if( su.dangerous )
	sfx_play( sfx_metal_collision );
        su.dangerous = 0;
	break;
      end
    end;
    
    if( blthres>0 ) blthres--; end
  
    if( bl=collision( type ball ) )
      if( bl.ingame && !blthres )
	sfx_play( sfx_metal_collision );
	spark( img_sparkle2, id );
	spark( img_sparkle2, id );
	pl = selfid;
	pl.mascot_points--;
	blthres = gam_fps;
	if( pl.mascot_points<=0 )
	  pl.mascot_points = gam_summon_hits;
	  m_pini_death( pl.side ? scr_width()+19 : -20 );
	end;
      end
    end
    
    if( pl = collision( type player ) )
      if( pl!=selfid && pl.effect_heavy )
	sfx_play( sfx_metal_collision );
	break;
      end
      if( pl!=selfid && pl.effect_ghost == 0 )
	sfx_play( sfx_scream );
	if( pl.effect_pain < gam_blood_frames ) pl.effect_pain = gam_blood_frames; end
	break;
      end
    end
    
    frame;
    
  end
  dangerous = 0;
  tick = 40;
  while( exists(pl) && pl.effect_pain>0 && tick>0)
    tick--;
    frame;
  end;
  vx =  x > scr_midx() ? rand( -4, -1 ) : rand( 1, 4 );
  vy = rand( -40, 10 );
  while( ! out_region( id, 0 ) )
    frame;
    x  += vx;
    y  += vy / 10;
    vy += 3;
  end;
end

/*-------------------------------------------------------*/

process axe( selfid, x, y )
begin
  sfx_play( sfx_metal_bell );
  z = wm_z_inact;
  graph = img_axe;
  vx =  x > scr_midx() ? -gam_bullet_spd1 : gam_bullet_spd1;
  bullet_reg( id, vx<0 );
  vy = 0;
  dangerous = 1;
  while( ! out_region( id, 0 ) && dangerous )
    angle -= 10000;
    x  += vx;
    y  += vy;
    
    // suriken won't stop axe
    if( su = collision( type suriken ) )
      if( su.dangerous )
	sfx_play( sfx_metal_collision );
        su.dangerous = 0;
      end
    end;
  
    if( pl = collision( type player ) )
      if( pl!=selfid && pl.effect_heavy )
	sfx_play( sfx_metal_collision );
	break;
      end
      if( pl!=selfid  && pl.effect_ghost == 0 )
	sfx_play( sfx_scream );
	pl.effect_ghost = gam_ghost_frames;
	pl.effect_pain  = gam_blood_frames / 10;
	break;
      end
    end
    frame;
  end
  dangerous = 0;
  tick = 40;
  while( exists(pl) && pl.effect_pain>0 && tick>0)
    tick--;
    frame;
  end;
  vx =  x > scr_midx() ? rand( -40, -10 ) : rand( 10, 40 );
  vy = rand( -40, 10 );
  while( ! out_region( id, 0 ) )
    frame;
    x  += vx/10;
    y  += vy/10;
    vy += 3;
  end;
end
/*-------------------------------------------------------*/

process wall( selfid, x, y )
begin
  z = wm_z_inact;
  graph = img_wall;
  vx =  x > scr_midx() ?   1 : -1;
  x  =  x > scr_midx() ? -10 : scr_width() + 10;
  
  tick = gam_fps;
  while( tick-- )
    frame;
    x += vx;
    
    if( pl = collision( type player ) )
      sfx_play( sfx_brick_collision );
      if( pl.effect_heavy )
	break;
      end
      if( pl.y > y ) 
	pl.y += graphic_info( file, img_platform, G_HEIGHT);
      else 
	pl.y -= graphic_info( file, img_platform, G_HEIGHT); 
      end
    end
  end
  
  tick = gam_fps*3;
  while( tick-- )
    frame;
    
    if( pl = collision( type player ) )
      sfx_play( sfx_brick_collision );
      if( pl.effect_heavy )
	break;
      end
      if( pl.y > y ) 
	pl.y += graphic_info( file, img_platform, G_HEIGHT);
      else 
	pl.y -= graphic_info( file, img_platform, G_HEIGHT); 
      end
    end
  end
  
  tick = gam_fps;
  
  while( tick-- )
    frame;
    x -= vx;
  
    if( pl = collision( type player ) )
      sfx_play( sfx_brick_collision );
      if( pl.effect_heavy )
	break;
      end
      if( pl.y > y ) 
	pl.y += graphic_info( file, img_platform, G_HEIGHT);
      else 
	pl.y -= graphic_info( file, img_platform, G_HEIGHT);
      end
    end
  end
  
end

/*---------------------------------------------------------------------------*/

process shield( selfid )
/*local
  player pl;
  int vx,vy, tick;
end*/
begin
  ani_new_loop( &lp, &ani_shield );
  alpha =127;
  tick = gam_fps*3;
  
  while( tick-- && exists(selfid) )
    x = selfid.x;
    y = selfid.y;
    graph = ani_next_frame( &lp );
    frame ;
  
    if( su = collision( type suriken ) )
      if( su.dangerous )
	sfx_play( sfx_metal_collision );
        su.dangerous = 0;
      end
    end;
    
    if( ax = collision( type axe ) )
      if( ax.dangerous )
	sfx_play( sfx_metal_collision );
        ax.dangerous = 0;
      end
    end;
    
  end
end

/*---------------------------------------------------------------------------*/

process player_status( player me )
local
  int i, j, t, ww, hh, bal;
  string sgn, sgn0, dofree;
end
begin
  ww = scr_midx();
  hh = scr_height();
  
  bal = ani_ball.frames[0];
  
  if( me.x < ww )
    x = 0;
  else
    x = ww*2;
    flags = B_HMIRROR;
  end
  y = 0;
  alpha = 130;
  z = 2;
  
  sgn = sgn0 = "";
  graph = 0;
  graph = map_new( ww, hh, 16 );
      set_center( file, graph, 0, 0 );
  
  loop
    sgn  = me.left_balls+",";
    sgn += me.mana+",";
    sgn += me.itemcnt+",";
    sgn += me.itemcnt+",";
    sgn += me.charged+"," + me.charge_invisible + "," + me.charge_rocketball;
    // update only if status changed
    if( sgn != sgn0 )
      //if( graph ) map_unload( file, graph ); end;
      map_clear( file, graph, 0 );
      drawing_map( file, graph);
      drawing_color( rgb( 20, 255, 50 ) );
      if( me.mana>0 ) draw_box( 0, 25, ww * me.mana / PLAYER_MAX_MANA, 28 ); end
      
      // lives
      //draw_box(0, 0, ww, 20 );
      for( i=0; i< me.left_balls; i++ )
	map_put( file, graph , bal , i*15+15, 15);
      end;
      
      // items
      //draw_box(0, hh-40, ww, hh );
      for( i=me.itemcnt-1, j=0 ; i>=0; i--, j++ )
	t = img_empt_item;
	switch( me.item[i] )
	  case PL_I_SURIKEN:
	    t = img_suriken;
	  end
	  case PL_I_AXE:
	    t = img_axe;
	  end
	  case PL_I_WALL:
	    t = img_wall;
	  end
	end
	if( j==0 )
	  map_xput( file, graph , t , 15, hh-35, 0, 150, 0 );
	else
	  map_put ( file, graph , t , j*8+25, hh-30 );
	end
      end;
      
      // charges
      if( me.charged ) 
	if( me.charge_invisible )  map_xput( file, graph , img_ico_invis  , 25, hh-15, 0 ,150, 0 );end;
	if( me.charge_rocketball ) map_xput( file, graph , img_ico_rocket , 45, hh-15, 0 ,150, 0 );end;
      else
	if( me.charge_invisible )  map_put( file, graph , img_ico_invis  , 25, hh-10 );end;
	if( me.charge_rocketball ) map_put( file, graph , img_ico_rocket , 45, hh-10 );end;
      end
    end
    
    sgn0 = sgn;
    frame 200;
    
  end;
onexit
  map_unload( file, graph );
end

/*-------------------------------------------------------*/

process turboflame( int selfid, int dir )
begin
  // dir = 0 - dir bottom
  // dir = 1 - dir top
  pl = selfid;
  ani_new_loop( &lp1, &ani_turboflame1 );
  ani_new_loop( &lp2, &ani_turboflame2 );
  x = pl.x;
  flags = B_ABLEND |  ( B_VMIRROR * !dir );
  t2=-1;
  while ( exists(pl) )
    t1 = graphic_info( file, pl.graph, G_HEIGHT );
  
    if( pl.y != t2 )
      if( dir )
	// moving down
	graph =  pl.y>t2 ? ani_next_frame(&lp2) : ani_next_frame(&lp1);
	alpha =  pl.y>t2 ? 255 : 0 ;
      else
	// moving up
	graph =  pl.y<t2 ? ani_next_frame(&lp2) : ani_next_frame(&lp1);
	alpha =  pl.y<t2 ? 255 : 0 ;
      end
    else
      graph = ani_next_frame(&lp1);
      alpha = 255;
    end
    
    y = pl.y + ( dir ? -1: 1 ) * ( t1 + 2 ) / 2;
  
    // even correction, some rendering feature (or my bug)
/*    if( t1 % 2 == 0 )
      y -= dir;
    end*/
    
    if( !pl.spd || pl.mana<=0 )
      alpha = 0;
    end
    
    t2 = pl.y;
    frame 200;
  end
end

/*-------------------------------------------------------*/
// shows if platform charged
process emarker( int typ, int selfid, int dir )
begin
  // dir = 0 - dir left
  // dir = 1 - dir right
  pl = selfid;
  
  ani_new_loop( &lp, typ ? &ani_wav2: &ani_wav1 );
  x = pl.x;
  z = pl.z;
  flags = dir ? B_HMIRROR : 0;
  
  while ( exists(pl) )
    if( pl.charged && ( (typ==0 && pl.charge_invisible) ||(typ==1 && pl.charge_rocketball)) )
      alpha = 255;
      y = pl.y;
      graph = ani_next_frame(&lp);
      frame;
    else      
      alpha = 0;
      frame;
    end
  end
  
end

/*--------------------------------------------------------*/

process sectionmarker( int anchor, int max )
begin
  loop
    x = anchor.x;
    y = anchor.y;
    k = param * 75 / max / 10;
    if(k<0) k=0; end
    if(k>7) k=7; end
    graph = ani_9sections.frames[ 7-k ];
    frame 200;
  end
end
