/*
    AGGRESSIVE PONG.
    Copyright (C) 2010  Eugene Popov (popov_e_n@mail.ru)

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>
*/

global
  int level_winner_side = -1;
end

/*-------------------------------------------------------*/

process level(int aicontrol1, int aicontrol2, int xai1, int xai2 )
local
  player p1, p2;
  int ai1=0, ai2=0;
  ball   b;
  int dfr;
end
begin
  level_winner_side = -1;
  p1 = player(0, aicontrol1, p1_input );
  p2 = player(1, aicontrol2, p2_input );
  player_status( p1 );
  player_status( p2 );
  signal(p1, S_SLEEP);
  signal(p2, S_SLEEP);
//   dfr = 90;
//   while(dfr>0) dfr--; frame; end;
  
  signal(p1, S_WAKEUP);
  signal(p2, S_WAKEUP);
  
  b  = ball();
  if( aicontrol1 )
    ai1 = exists(xai1) ? xai1 : ai_tunable_loop(p2, p1, b);
    tune_ai_level_exelent( ai1 );
    update_ai( ai1, p2, p1, b );
  end
  if( aicontrol2 )
    ai2 = exists(xai2) ? xai2 : ai_tunable_loop(p1, p2, b);
    tune_ai_level_exelent( ai2 );
    update_ai( ai2, p1, p2, b );
  end
  
  loop
    if( ! exists(b) )
      sfx_play( sfx_metal_don );
      if( victum ==0 )
	p1.left_balls--;
	if( p1.left_balls==0 )
	  level_winner_side = 1;
	  dfr = gm_endlevel_menu( "  Player 2 WINS !  " );
	  while( exists( dfr) ) frame; end;
	  return;
	end;
      else
	p2.left_balls--;
	if( p2.left_balls==0 )
	  level_winner_side = 0;
	  dfr= gm_endlevel_menu( "  Player 1 WINS !  " );
	  while( exists( dfr) ) frame; end;
	  return;
	end;
      end;
      b  = ball();
      if( aicontrol1 )
	  update_ai( ai1, 0, 0, b );
      end
      if( aicontrol2 )
	  update_ai( ai2, 0, 0, b );
      end
    end;
    frame;
  end
onexit
  if(exists(p1)) signal( p1, S_KILL); end
  if(exists(p2)) signal( p2, S_KILL); end
  if(exists(b)) signal( b, S_KILL); end
  signal( type item, S_KILL);
  signal( type m_pini_death, S_KILL);
  signal( type gmarker, S_KILL);
  signal( type emarker, S_KILL);
  signal( type suriken, S_KILL);
  signal( type axe, S_KILL);
  signal( type wall, S_KILL);
  signal( type shield, S_KILL);
  signal( type player_status, S_KILL);
  if(exists(ai1)) signal( ai1, S_KILL); end
  if(exists(ai2)) signal( ai2, S_KILL); end
end;

function level_pause()
begin
  pause_song();
  signal( type player, S_FREEZE);
  signal( type m_pini_death, S_FREEZE);
  signal( type ai_tunable_loop, S_FREEZE);
  signal( type gmarker, S_FREEZE);
  signal( type emarker, S_FREEZE);
  signal( type ball, S_FREEZE);
  signal( type item, S_FREEZE);
  signal( type suriken, S_FREEZE);
  signal( type axe, S_FREEZE);
  signal( type wall, S_FREEZE);
  signal( type shield, S_FREEZE);
end;

function level_unpause()
begin
  resume_song();
  signal( type player, S_WAKEUP);
  signal( type m_pini_death, S_WAKEUP);
  signal( type ai_tunable_loop, S_WAKEUP);
  signal( type gmarker, S_WAKEUP);
  signal( type emarker, S_WAKEUP);
  signal( type ball, S_WAKEUP);
  signal( type item, S_WAKEUP);
  signal( type suriken, S_WAKEUP);
  signal( type axe, S_WAKEUP);
  signal( type wall, S_WAKEUP);
  signal( type shield, S_WAKEUP);
end;
