#define LISTS_STATIC
/*
    AGGRESSIVE PONG.
    Copyright (C) 2010  Eugene Popov (popov_e_n@mail.ru)

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>
*/

global
  string game_version = "0.21";
  int default_bpp = 16;
end

#include "../lib/input_module.inc.prg"
#include "../lib/wm.inc.prg"
#include "../lib/wm_utils.inc.prg"
#include "../lib/translate.inc.prg"

function mapto16( int map )
local int new; end
begin
  new = map_new( graphic_info( file, map, G_WIDTH ), graphic_info( file, map, G_HEIGHT ), default_bpp );
  map_put( file, new, map, graphic_info( file, map, G_X_CENTER ), graphic_info( file, map, G_Y_CENTER ) );
  map_unload( file, map );
  return new;
end

import "mod_video"
import "mod_map"
//import "mod_proc"
import "mod_grproc"
import "mod_rand"
import "mod_screen"
import "mod_time"
import "mod_wm" // for exit_status
import "mod_scroll"

#include "resolutions.inc.prg"
       
       
global
  int os_handheld = 0;  
end  

#define PCMD_UP 1
#define PCMD_DOWN 2
#define PCMD_ITEM 4
#define PCMD_DEFENCE 8
#define PCMD_SPEEDUP 16
#define PCMD_CHARGE  32

/*--------------------------------------------------------*/

#include "sfx.inc.prg"
#include "animation.inc.prg"
#include "options.inc.prg"
#include "controls.inc.prg"

global
  
  int img_bg_level_a = 0;
  int img_bg_level_b = 0;
  int img_inter_l = 0;  
  int img_inter_r = 0;  
  int img_title1 = 0; // agressive
  int img_title2 = 0; // pong
  
  int img_platform   = 0;
  int img_platformw  = 0; // wide
  int img_platformh  = 0; // heavy

  ani_file ani_ball;
  ani_file ani_shield;
  ani_file ani_items;
  ani_file ani_items_dual;
  ani_file ani_items_negative;
  ani_file ani_turboflame1;
  ani_file ani_turboflame2;
  ani_file ani_marker;
  ani_file ani_wav1;
  ani_file ani_wav2;
  ani_file ani_9sections;
  
  int img_empt_item   = 0;
  
  // green items
  int img_mana     = 0;
  int img_mana_bar = 0;
  int img_ico_suriken = 0;
  int img_ico_axe = 0;
  int img_ico_wall = 0;
  int img_ico_invis = 0;
  int img_ico_rocket = 0;
  int img_ico_wide = 0;

  int img_suriken = 0;
  int img_axe = 0;
  int img_wall = 0;
  
  // blue items (dual effect)
  int img_ico_heavy = 0;
  int img_ico_equalize = 0;
  int img_ico_stopball = 0;
  
  // red items (negative)
  int img_ico_damage = 0;
  int img_ico_neg_rocket = 0;
  
  // others
  int img_sparkle = 0;
  int img_sparkle2 = 0;
  int img_blood = 0;
  
  /// game mode constants:
  int gam_fps = 20; // speed factor;
  int gam_platform_spd; // = gam_fps / 10; // player normal speed;
  int gam_platform_boost; // = gam_platform_mov * 3; // player fast speed
  int gam_ball_spd; // = gam_fps / 4; // ball default advance
  int gam_ball_boost; // = gam_ball_spd * 3; // charged ball advance

  int gam_item_spd; // speed of falling prize
  int gam_bullet_spd1;  // slow bullet spd ( axe )
  int gam_bullet_spd2; // fast bullet spd ( suriken )
  int gam_blood_frames; // base number of frames to bleed
  int gam_ghost_frames; // base number of frames to be ghost
  int gam_max_mana;
  int gam_max_balls;
  int gam_summon_hits;
  int gam_platform_spdslow;
  int gam_ball_stop_time;
  
  int sys_mon;
  

end
/*-------------------------------------------------------*/

function select_mode(int fs)
local
  int flg, pref_w, pref_h, pref_bpp;
end
begin
//  exit;
  gam_scr_width  = 320;
  gam_scr_height = 240;
  gam_scr_midx  = 160;
  gam_scr_midy = 120;
  gam_scr_fps = 30;
  
  if( os_handheld )
    pref_w = 320;
    pref_h = 240;
    flg = 0;
    pref_bpp = 16;
  else
    scale_mode = SCALE_NORMAL2X;
    if( fs )
      flg = MODE_2XSCALE | MODE_FULLSCREEN;
    else
      flg = MODE_2XSCALE;
    end
    pref_w = 320;
    pref_h = 240;
    pref_bpp = 16;
  end
  
  detect_resolutions( pref_bpp, flg | MODE_FULLSCREEN );
  
  default_bpp = pref_bpp;
  set_mode( pref_w, pref_h, pref_bpp, flg);
  
  //set_fps( gam_scr_fps, 1 );
  set_fps( gam_scr_fps, 0 );
  
  
end

/*-------------------------------------------------------*/

#include "intro.inc.prg"
#include "gamemenu.inc.prg"

/*-------------------------------------------------------*/

function load_graphics()
local
  int items, sz;
end
begin
 // img_bg_level_a = png_load("../data/bg-level.png");
  img_bg_level_b = mapto16( png_load("../data/bg-cell.png") );
  frame 0;
  img_inter_l = mapto16( png_load("../data/ims-l.png") );
  img_inter_r = mapto16( png_load("../data/ims-r.png") );
  set_center( file, img_inter_l, graphic_info( file, img_inter_l, G_WIDTH ), graphic_info( file, img_inter_l, G_HEIGHT ) /2 );
  set_center( file, img_inter_r, 0, graphic_info( file, img_inter_r, G_HEIGHT ) /2 );
  frame 0;
  
  img_title1 = mapto16( png_load('../data/title-agressive.png') );
  set_center( file, img_title1, 0, 0 );
  img_title2 = mapto16( png_load('../data/title-pong.png') );
  set_center( file, img_title2, 0, 0 );
  
  img_platform   = mapto16( png_load("../data/platform.png"));
  img_platformw  = mapto16( png_load("../data/platform-wide.png"));
  img_platformh  = mapto16( png_load("../data/platform-heavy.png"));
  img_sparkle   = mapto16( png_load("../data/sparkle.png"));
  img_sparkle2  = mapto16( png_load("../data/sparkle-2.png"));
  img_mana_bar = mapto16( png_load("../data/sparkle.png"));
  img_blood    = mapto16( png_load("../data/blood.png"));
  frame 0;
  
  ani_load( &ani_ball,  "../data/ball2.png",  0 );
  ani_load( &ani_9sections,  "../data/9-sections.png",  1 );
  ani_load( &ani_shield,"../data/shield.png", 0 );
  frame 0;

  ani_load( &ani_turboflame1,"../data/flame-normal.png",1 );
  ani_set_center( &ani_turboflame1, ani_turboflame1.fw/2, ani_turboflame1.fh-1);
  ani_load( &ani_turboflame2,"../data/flame-turbo.png", 1 );
  ani_set_center( &ani_turboflame2, ani_turboflame2.fw/2, ani_turboflame2.fh-1);
  ani_load( &ani_marker,"../data/goal-marker.png", 1 );
  ani_set_center( &ani_marker, 0, ani_marker.fh/2);
  ani_load( &ani_wav1,"../data/wave-1.png", 1 );
  ani_set_center( &ani_wav1, 10, ani_wav1.fh/2);
  ani_load( &ani_wav2,"../data/wave-2.png", 1 );
  ani_set_center( &ani_wav2, 10, ani_wav2.fh/2);
  frame 0;

  /*
  items    = png_load("../data/items-2.png");
  sz = graphic_info( file, items, G_HEIGHT );
  */
  
  ani_load( &ani_items,  "../data/items-2.png",  1);
  frame 0;
  
  img_empt_item = ani_items.frames[0];
  img_mana	= ani_items.frames[1];
  img_suriken	= ani_items.frames[3];
  img_axe	= ani_items.frames[7];
  img_wall	= ani_items.frames[9];
  
  img_ico_suriken = map_clone( file, img_empt_item );
  img_ico_axe     = map_clone( file, img_empt_item );
  img_ico_wall    = map_clone( file, img_empt_item );
  img_ico_invis   = map_clone( file, img_empt_item );
  img_ico_rocket  = map_clone( file, img_empt_item );
  img_ico_wide    = map_clone( file, img_empt_item );
  frame 0;
  
  map_put( file, img_ico_suriken, ani_items.frames[  2 ], ani_items.fw/2, ani_items.fh/2);
  map_put( file, img_ico_axe,     ani_items.frames[  6 ], ani_items.fw/2, ani_items.fh/2);
  map_put( file, img_ico_wall,    ani_items.frames[  8 ], ani_items.fw/2, ani_items.fh/2);
  map_put( file, img_ico_invis,   ani_items.frames[  4 ], ani_items.fw/2, ani_items.fh/2);
  map_put( file, img_ico_rocket,  ani_items.frames[  5 ], ani_items.fw/2, ani_items.fh/2);
  map_put( file, img_ico_wide,    ani_items.frames[ 10 ], ani_items.fw/2, ani_items.fh/2);
  frame 0;
  
  ani_load( &ani_items_dual,  "../data/items-dual.png",  1);
  frame 0;
  
  img_empt_item = ani_items_dual.frames[0];
  
  img_ico_heavy    = map_clone( file, img_empt_item );
  img_ico_equalize = map_clone( file, img_empt_item );
  img_ico_stopball = map_clone( file, img_empt_item );
  frame 0;
  
  map_put( file, img_ico_heavy,    ani_items_dual.frames[ 1 ], ani_items_dual.fw/2, ani_items_dual.fh/2);
  map_put( file, img_ico_equalize, ani_items_dual.frames[ 2 ], ani_items_dual.fw/2, ani_items_dual.fh/2);
  map_put( file, img_ico_stopball, ani_items_dual.frames[ 3 ], ani_items_dual.fw/2, ani_items_dual.fh/2);
  frame 0;

  ani_load( &ani_items_negative,  "../data/items-negative.png",  1);
  frame 0;
  
  img_empt_item = ani_items_negative.frames[0];
  
  img_ico_damage    = map_clone( file, img_empt_item );
  img_ico_neg_rocket = map_clone( file, img_empt_item );
  frame 0;
  
  map_put( file, img_ico_damage,    ani_items_negative.frames[ 1 ], ani_items_negative.fw/2, ani_items_negative.fh/2);
  map_put( file, img_ico_neg_rocket, ani_items_negative.frames[ 2 ], ani_items_negative.fw/2, ani_items_negative.fh/2);
  frame 0;

end;

/*-------------------------------------------------------*/

#include "gameobjects.inc.prg"
#include "pongai.inc.prg"
#include "level.inc.prg"
#include "game.demo.inc.prg"
#include "game.versus.inc.prg"
#include "game.story.inc.prg"
#include "scroller.inc.prg"

#include "mascots.inc.prg"

/*-------------------------------------------------------*/

process exiter()
begin
  loop
    if( exit_status ) let_me_alone(); frame; exit('(X__X)'); end
    frame;
  end
end

/*-------------------------------------------------------*/
local
 int i, j;
end
begin
  rand_seed( time() );
  
  gam_fps = 20; // speed factor;
  gam_platform_spd   = gam_fps / 6; // player normal speed;
  gam_platform_boost = gam_platform_spd * 2; // player fast speed
  gam_ball_spd   = gam_fps / 4; // ball default advance
  gam_platform_spdslow  = gam_fps / 8;
  gam_ball_boost = gam_ball_spd * 3; // charged ball advance
  gam_item_spd   = gam_fps / 20; // speed of falling prize
  gam_bullet_spd1  = gam_fps / 3; // slow bullet spd ( axe )
  gam_bullet_spd2  = gam_fps / 2; // fast bullet spd ( suriken )
  gam_blood_frames = gam_fps * 3; // base number of frames to bleed
  gam_ghost_frames = gam_fps * 6; // base number of frames to be ghost
  gam_max_mana = 300;
  gam_max_balls = 3; // lives
  gam_summon_hits = 4;
  gam_ball_stop_time = gam_fps * 5;
  
  // GPH OSes
  os_handheld = ( os_id == 4 || os_id== 7 || os_id== 8 || os_id== 9 );
  //os_handheld = 1;
  
  load_options( options_file );
  load_state( state_file );
  
  translation_load( option_locale );
    
  select_mode( option_fulscreen_on );
  sfx_sound_on ( option_sound_on );
  sfx_music_theme( sfx_music_scheme );
  
  text_set_frontend( TXT_RENDER_F_CFNT );
  
  i = option_gspainsplash_on ? intro() : 0;
  
  //say('Loading translation');

  say('Loading graphics');
  load_graphics();
  say('Loading mascots');
  load_mascots();
  say('Loading sounds');
  sfx_load();
  say('Loaded');
  
  input_module( 80 );
  
  exiter();
  
  frame 0;
    
  wm_manager_simple();
  wm_load_skin('../data/wmskin.png');
  
  frame 0;
  
  gm_volume_menu( );
  
  frame 0;
  
//  map_put( 0, 0, img_bg_level_a, scr_width()/2, scr_height()/2);
  
  init_scroller( img_bg_level_b );
  
  //graph= img_sparkle;
  
  // wait splash
  //titlescreen();
  while( exists(i) ) frame; end;
   
  sys_mon = 0;
  
  titlescreen();
  set_scroll(2, -1);
    
  i = init_controls();  
  while( exists(i) ) frame; end;
  
  // main loop
  loop
  
    if( !exists( type titlescreen ) ) titlescreen(); end;
    
    input_set_dev( p1_input );
    i = gm_main_menu();  
    
    sfx_music( sfx_song_intro );
    
    set_scroll(2, -1);
    while( exists(i) )
      // cheats & special cases are here (while main menu shown)  
      frame;
    end;
    
    signal(type titlescreen, S_KILL);
    
    sfx_music( sfx_song_level );
    
    switch( gamemenu_mode )
      case GMM_MODE_DEMO :
	i = gamedemo();
      end
      case GMM_MODE_STORY :
	if( state_unlocked )
	  i = gm_selectlevel_menu( state_unlocked );
	  while( exists(i) ) frame; end;
	  if( gamemenu_mode == 0 ) continue; end
	  i = gamestory( gamemenu_mode );
	else
	  i = gamestory( 1 );
	end
      end
      case GMM_MODE_1P :
	i = gameversuscpu();
      end
      case GMM_MODE_2P :
	i = gameversus2p();
      end

    end
    
    while( exists(i) )      
    
      if( jkey( _JKEY_MENU ) ) 
	signal(i, S_SLEEP);
	level_pause();
	frame;
      
	j = gm_ingame_menu();  
	while( exists(j) ) 
	  frame;
	end;
	
	switch( gamemenu_mode )
	  case GMM_MODE_CONTINUE :
	    signal(i, S_WAKEUP);
	    level_unpause();
	    frame;
	  end
	  case
	  GMM_MODE_EXIT:
	    break;
	  end
	end	
      end;
      
      frame;
    end
    
    signal( i, S_KILL );
    frame;
       
  end;
  
  let_me_alone();
end;
