/*
    AGGRESSIVE PONG.
    Copyright (C) 2010  Eugene Popov (popov_e_n@mail.ru)

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>
*/

global
  ani_file pini_walk;
  ani_file pini_to_death;
  int pini_scyte;
  int pini_scyte_strike;
end

function load_mascots()
begin
  ani_load( &pini_walk, "../data/pini/walk.png", 1 );
  ani_set_center( &pini_walk, pini_walk.fw/2, pini_walk.fh-1);
  
  ani_load( &pini_to_death, "../data/pini/to-death.png", 1 );
  ani_set_center( &pini_to_death, pini_to_death.fw/2, pini_to_death.fh-1 );
  
  pini_scyte = mapto16( png_load ("../data/pini/scyte.png") );
  set_center( file, pini_scyte, graphic_info(file, pini_scyte, G_WIDTH)/2, graphic_info(file, pini_scyte, G_HEIGHT)-1 );
  
  pini_scyte_strike = mapto16(png_load ("../data/pini/scyte-strike.png") );
  set_center( file, pini_scyte_strike, pini_to_death.fw/2, graphic_info(file, pini_scyte, G_HEIGHT)-1 );
end

process m_pini_scyte( int x )
begin
  y = y = scr_height() -1;
  z = 0;
  alpha = wm_z_act - 2;;
  graph = pini_scyte;
  
  while(alpha<255)
    alpha  += 10;
    frame;
  end
  loop
    frame;
  end;
end

process m_pini_death( int x )
local
  int vx, vy, distx, dir;
  ani_loop lp;
  int scyte;
  player pl;
  ball bl;
  int fscream;  
end
begin
  scyte = 0;
  dir = vx = x<0 ? +1: -1;
  flags = x<0 ? 0 : B_HMIRROR ;
  y = scr_height() -1;
  z = wm_z_act - 1;
  
  distx = dir * scr_width()*4/5;
  ani_new_loop( &lp, &pini_walk );
  
  bl = get_id( type ball );
  
  while( dir*distx >0 )
    graph = ani_next_frame( &lp );
    x     += vx;
    distx -= vx;
    frame 200;
  end
  
  ani_new_loop( &lp, &pini_to_death );
  
  while( !lp.ani_end )
    graph = ani_next_frame( &lp );
    frame 300;
  end
  
  scyte = m_pini_scyte( x );
  
  while(scyte.alpha < 255)
    frame 300;
  end
  
  signal(scyte, S_KILL);
  
  graph = pini_scyte_strike;
  
  // значеня захардкожены, при другом разрешении не поканает
  vx = dir;
  vy = -20;
  fscream = 0;
  while( !out_region( id, 0 ) )
    x  += vx;
    y  += vy;
    vy += 1;
    frame;
    if( pl = collision(type player) )
      if(!fscream) sfx_play( sfx_scream ); fscream=1; end
      pl.effect_pain = gam_fps*20;
      //pl.effect_ghost = 800;
      pl.mana = 0;
      pl.itemcnt = 0;
      pl.charged = 0;
    end
  end;
  signal( bl, s_wakeup );  
onexit
 if( exists(scyte) ) signal(scyte, S_KILL); end
end
