/*
    AGGRESSIVE PONG.
    Copyright (C) 2010  Eugene Popov (popov_e_n@mail.ru)

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>
*/

import "mod_math"

/*
declare process ai_loop(int op, int sf, int bl)
public
  player ai_self     = 0;
  player ai_opponent = 0;
  ball   ai_ball     = 0;
end
local
  int tgy, t1,t2,t3, pwd;
end
end
*/

/*------------------------------------------------------------------------------------------*/

declare process ai_tunable_loop(int op, int sf, int bl)
public
  player ai_self = 0, ai_opponent = 0;
  ball ai_ball = 0;
  int pwd, pwd2, tgy;
  int t1, t2, t3;
  item prz;
  
  int opt_prize_catcher = 0;
  int opt_deflector = 0; // uses shield
  int opt_agressive = 0; // uses items
  int opt_surprizer = 0; // uses effects
  int opt_speedy    = 0; // uses speedup
  int opt_sauron    = 0; // sees invisible ball
  int opt_prediction_level = 1; // number of ball reflections to apprise
  int opt_mascot_summoner  = 0; // sknows how to summon mascot
end
end

/*------------------------------------------------------------------------------------------*/

function update_ai( ai_tunable_loop ai, int op, int sf, int bl )
begin
  if( op ) ai.ai_opponent = op; end;
  if( sf ) ai.ai_self     = sf; end;
  if( bl ) ai.ai_ball     = bl; end;
end

/*------------------------------------------------------------------------------------------*/

function is_ball_flys_to_me( ai_tunable_loop ai )
begin
  if( !ai.ai_ball.ingame ) return 0; end;
  if( ai.ai_self.x > scr_midx() )
    return cos(ai.ai_ball.xangle) > 0;
/*    if( ai.ai_ball.alpha<255 || ai.ai_ball.adv> gam_ball_spd )
      // always catching thogh balls
      return cos(ai.ai_ball.xangle) > 0;
    else
      return ai.ai_ball.x > scr_midx() && cos(ai.ai_ball.xangle) > 0;
    end*/
  else
    return cos(ai.ai_ball.xangle) < 0;
/*    if( ai.ai_ball.alpha<255 || ai.ai_ball.adv> gam_ball_spd )
      return cos(ai.ai_ball.xangle) < 0;
    else
      return ai.ai_ball.x < scr_midx() && cos(ai.ai_ball.xangle) < 0;
    end*/
  end
end;

/*------------------------------------------------------------------------------------------*/

function get_ball_collision_y( ai_tunable_loop ai, int deepness )
local
  int norm_angle;
  int norm_x, norm_y, res;
end
begin
  if( cos( ai.ai_ball.xangle ) > 0)
    norm_angle = 180000 - ai.ai_ball.xangle;
    norm_x = scr_width() - ai.ai_ball.x;
    norm_y = ai.ai_ball.y;
  else
    norm_angle = ai.ai_ball.xangle;
    norm_x = ai.ai_ball.x;
    norm_y = ai.ai_ball.y;
  end
  res = norm_y + tan( norm_angle ) * norm_x;
  while ( deepness-- )
    if( res < 0 )
      res = -res;
    end
    if( res > scr_height() )
      res = scr_height() -  res + scr_height();
      res = -res;
    end
    if( res >= 0 && res <= scr_height() ) return res; end;
  end
  return res;
end;

/*------------------------------------------------------------------------------------------*/

process ai_tunable_loop(int op, int sf, int bl)

begin
  update_ai(id, op, sf, bl);
  
  // wait level for appear; need for pretunning
  while( !exists( ai_self ) || !exists( ai_ball ) || !exists( ai_opponent ) ) frame; end;
  
  t2 = 0; // closest prize
  t3 = 0; // closest bullet
  pwd  = graphic_info( file, ai_self.graph, G_HEIGHT ); // platform normal width
  pwd2 = pwd / 2;
  loop
    frame;
    
    if( ! exists( ai_self ) ) return; end
      
    if( exists( ai_ball ) && exists( ai_opponent ) )
      
      if( opt_deflector  )
	// deflect bullet
	t3 = bullet_closest( !ai_self.side );
	if( t3 && exists(t3) )
	  if( abs( ai_self.y - t3.y) < pwd && abs ( ai_self.x - t3.x ) < scr_width()/4 )
	    ai_self.p_cmd |= PCMD_DEFENCE;
	  end
	end
      end
      
      // shoot stopped
      if( opt_agressive && opt_mascot_summoner && ai_ball.stopped && ai_self.itemcnt>0 )
	if( ai_self.item[ai_self.itemcnt-1] == PL_I_SURIKEN )
	  ai_self.p_cmd |= PCMD_SPEEDUP;
	  if( ai_self.y > ai_ball.y + pwd/4 ) ai_self.p_cmd |= PCMD_UP; continue; end
	  if( ai_self.y < ai_ball.y - pwd/4 ) ai_self.p_cmd |= PCMD_DOWN; continue; end
	  ai_self.p_cmd |= PCMD_ITEM;
	  continue;
	end
      end
      
      t1 = is_ball_flys_to_me( id );
      // check if ball hits near center, and it is slow
      //
      loop
	if( t1 )

	  if( ai_ball.adv<=gam_ball_spd && abs( ai_ball.x - ai_self.x  )+15 > scr_width()*25/40 )
	    //say('FAR '+id+'/'+timer[6]);
	    // then we are free to do other deeds
	    t1 = 0;
	    break;
	  end
	  if( ai_ball.adv<=gam_ball_spd && abs( ai_ball.x - ai_self.x  )+15 > scr_width()/2 && abs( ai_ball.y - scr_midy() ) < scr_midy()/2 )
	    //say('MID '+id+'/'+timer[6]);
	    // then we are free to do other deeds
	    t1 = 0;
	    break;
	  end
	  if( ai_ball.adv<=gam_ball_spd && abs( ai_ball.x - ai_self.x ) > scr_width()/4 && ai_self.mana > scr_midy()/gam_platform_spd  )
	    //say('FST '+id+'/'+timer[6]);
	    // then we are free to do other deeds
	    t1 = 0;
	    break;
	  end
	end
	break;
      end

      if( t1 )
	prz = 0;

	  if( opt_sauron || ai_ball.alpha > 100 )
	    tgy = get_ball_collision_y( id, opt_prediction_level  );
	  end
	// bounce balll
	
	  if( ai_self.y > tgy + pwd/8 ) 
	    ai_self.p_cmd |= PCMD_UP; 
	    if( opt_speedy ) ai_self.p_cmd |= PCMD_SPEEDUP; end
	  end;
	
	  if( ai_self.y < tgy - pwd/8 )
	    ai_self.p_cmd |= PCMD_DOWN;
	    if( opt_speedy ) ai_self.p_cmd |= PCMD_SPEEDUP; end
	  end;
	  
	  //try summon
//	  if( opt_agressive /*&& ai_self.itemcnt>0 */&& opt_mascot_summoner && abs( ai_self.x - ai_ball.x )< pwd && abs( ai_self.y - ai_ball.y )< pwd )
//	    ai_self.p_cmd |= PCMD_ITEM;
//	    say('SUM1 '+ ( ai_self.p_cmd & PCMD_ITEM ) );
//	  end
	  
	  if( opt_surprizer && !ai_self.charged ) ai_self.p_cmd |= PCMD_CHARGE; end
	    
      else
	
	//try summon
	t3 = abs( ai_self.x - ai_ball.x );
	if( opt_agressive && ai_self.itemcnt>0 && opt_mascot_summoner && t3>pwd2 && t3 < pwd*2 && abs( ai_self.y - ai_ball.y )< pwd )
	  ai_self.p_cmd |= PCMD_ITEM;
	end
	  
	t3 = 0;
	if( opt_prize_catcher && ( !prz || !exists(prz) ) ) prz = prize_closest( !ai_self.side ); end
	if( opt_prize_catcher && prz && abs(prz.x-ai_self.x)<scr_width()/4)
	  
	  // get prize ? O_o
	  if( prz.negative )
	    // No, no, no!
	    if( ai_self.y < prz.y + pwd  && ai_self.y > prz.y - pwd )
	      //say('I SEE IT '+ai_self.x+' '+timer[6]);
	      if( ai_self.y < prz.y ) ai_self.p_cmd |= PCMD_UP; end
	      if( ai_self.y > prz.y ) ai_self.p_cmd |= PCMD_DOWN; end
/*	      if( ai_self.y< scr_midy() && ai_self.y < prz.y + pwd ) ai_self.p_cmd |= PCMD_DOWN; end
	      if( ai_self.y< scr_midy() && ai_self.y > prz.y - pwd ) ai_self.p_cmd |= PCMD_UP; end
	      if( ai_self.y> scr_midy() && ai_self.y < prz.y + pwd ) ai_self.p_cmd |= PCMD_DOWN; end
	      if( ai_self.y> scr_midy() && ai_self.y > prz.y - pwd ) ai_self.p_cmd |= PCMD_UP; end
*/
	    end
	    continue;
	  end

	  if( !prz.dual )
	     //normal green prize
	    if( ai_self.y > prz.y + pwd2 ) ai_self.p_cmd |= PCMD_UP; end
	    if( ai_self.y < prz.y - pwd2 ) ai_self.p_cmd |= PCMD_DOWN; end
	    if( abs( ai_self.y - prz.y) > pwd*2 && abs ( ai_self.x - prz.x ) < scr_width()/6 )
	      if( opt_speedy ) 
		ai_self.p_cmd |= PCMD_SPEEDUP; 
	      end
	    end
	  else
	    // dulal
	    switch( prz.typ )
	      case PL_I_HEAVY:
		if( ai_self.itemcnt>4 && ai_self.mana> gam_max_mana / 2 )
		  if( ai_self.y > prz.y + pwd2 ) ai_self.p_cmd |= PCMD_UP; end
		  if( ai_self.y < prz.y - pwd2 ) ai_self.p_cmd |= PCMD_DOWN; end
		  if( abs( ai_self.y - prz.y) > pwd*2 && abs ( ai_self.x - prz.x ) < scr_width()/6 )
		    if( opt_speedy ) 
		      ai_self.p_cmd |= PCMD_SPEEDUP; 
		    end
		  end
	    end
	      end
	      case PL_I_EQUALIZE:
		if( (ai_opponent.itemcnt>ai_self.itemcnt) || ( ai_self.itemcnt==0 && ai_opponent.mana> ai_self.mana) || (ai_opponent.charge_invisible && ai_opponent.charge_rocketball) )
		  if( ai_self.y > prz.y + pwd2 ) ai_self.p_cmd |= PCMD_UP; end
		  if( ai_self.y < prz.y - pwd2 ) ai_self.p_cmd |= PCMD_DOWN; end
		  if( abs( ai_self.y - prz.y) > pwd*2 && abs ( ai_self.x - prz.x ) < scr_width()/6 )
		    if( opt_speedy ) 
		      ai_self.p_cmd |= PCMD_SPEEDUP; 
		    end
		  end
	    end
	      end
	      case PL_I_STOPBALL:
		if( opt_mascot_summoner && ai_self.itemcnt> 3 && ai_opponent.itemcnt<2 )
		  if( ai_self.y > prz.y + pwd2 ) ai_self.p_cmd |= PCMD_UP; end
		  if( ai_self.y < prz.y - pwd2 ) ai_self.p_cmd |= PCMD_DOWN; end
		  if( abs( ai_self.y - prz.y) > pwd*2 && abs ( ai_self.x - prz.x ) < scr_width()/6 )
		    if( opt_speedy ) 
		      ai_self.p_cmd |= PCMD_SPEEDUP; 
		    end
		  end
		end;
	      end
	    end;  
	  end
	else
	  
	  // to center
	  if( ai_self.y > ( scr_midy()+pwd2 ) ) ai_self.p_cmd |= PCMD_UP; end
	  if( ai_self.y < ( scr_midy()-pwd2 ) ) ai_self.p_cmd |= PCMD_DOWN; end
	end
      end
      
      // shoot him ? O_o      
      if( opt_agressive && ai_self.itemcnt>0 && ai_opponent.effect_heavy<=0)	
	switch( ai_self.item[ai_self.itemcnt-1] )
	  case PL_I_SURIKEN :
	    // просто кидать при случае
	    if( abs( ai_self.y - ai_opponent.y ) < 15 ) ai_self.p_cmd |= PCMD_ITEM; end
	  end
	  case PL_I_AXE :
	    // кинуть топор вдогонку
	    if( !t1 && abs( ai_self.y - ai_opponent.y ) < 15 ) ai_self.p_cmd |= PCMD_ITEM; end
	  end
	  case PL_I_WALL :
	    // поставить палку в колёса
	    if( !t1 )
	      tgy = get_ball_collision_y( id, opt_prediction_level );
	      if( (ai_self.y > tgy && ai_opponent.y > tgy && ai_self.y < ai_opponent.y ) || 
		  (ai_self.y < tgy && ai_opponent.y < tgy && ai_self.y > ai_opponent.y ) )
		ai_self.p_cmd |= PCMD_ITEM; 
	      end
	    end
	  end
	end
	
      end
    end

  end;
end;

/*-------------------------------------------------------------------------------------------------*/