/*
    Bennu Convinience Lib Set.
    Copyright (C) 2010  Eugene Popov (popov_e_n@mail.ru)

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>
*/

import "mod_sound"

global
  //sfx
  int sfx_metal_bell = 0;
  int sfx_metal_collision = 0;
  int sfx_metal_don = 0;
  int sfx_ribbon_collision = 0;
  int sfx_scream = 0;
  int sfx_brick_collision = 0;
  
  // music
  int sfx_song_intro = 0;
  int sfx_song_level = 1;
  
  int sfx_song_playing = -1;
  int sfx_song_res = -1;
  string *sfx_song_files;
  string sfx_song_files1[] = ( "../data/songs/initiation(ivory).ogg", "../data/songs/invincible(ivory).ogg" );
  string sfx_song_files2[] = ( "../data/songs/free-jazz.ogg", "../data/songs/green-forest.ogg" );
  string sfx_music_schemes[] = ("Silence", "Ivory  ", "Calm   ", "");
  
  int sfx_sound_on = 1;
  int sfx_music_on = 1;
  int sfx_music_scheme = 1;
  int sfx_sound_volume = 25;
  
  int sfx_channel_tt=0;
  int sfc=0;
  
end

//////////////////////////////////////////////////////////////////////

declare function sfx_change_volume( int delta )
end

//////////////////////////////////////////////////////////////////////

function sfx_load()
begin
  sfx_metal_bell       = load_wav("../data/sfx/din.wav");
  frame 0; // frames for async loading;
  sfx_metal_collision  = load_wav("../data/sfx/dzin.wav");
  frame 0;
  sfx_ribbon_collision = load_wav("../data/sfx/tum2.wav");
  frame 0;
  sfx_scream 	       = load_wav("../data/sfx/agh.wav");
  frame 0;
  sfx_metal_don        = load_wav("../data/sfx/goal.wav");  
  frame 0;
  sfx_brick_collision  = load_wav("../data/sfx/tum-brick.wav");
  
  sfx_change_volume( 0 );
end

/*-------------------------------------------------------------------------*/

function sfx_play( int sfx )
begin
  if( ! sfx_sound_on ) return; end;
  play_wav( sfx, 0, sfc++%8);
end

/*-------------------------------------------------------------------------*/

function sfx_music( int song )
begin
  sfx_song_playing = song;
  
  if( ! sfx_music_on ) return; end;
  
  if( sfx_song_res!=-1 )
    unload_song( sfx_song_res );
    sfx_song_res =-1;
  end
  
  if(song>=0)
    say('Song: '+sfx_song_files[song]);
    sfx_song_res = load_song( sfx_song_files[song] );
    play_song( sfx_song_res, -1 );
  else
    say('No song');
  end
  
end

/*-------------------------------------------------------------------------*/

function sfx_sound_on( int seton )
begin
  sfx_sound_on = seton;
end

/*-------------------------------------------------------------------------*/

function sfx_music_on( int seton )
begin
  if(sfx_music_on && !seton)
    pause_song();
  end;
  if( !sfx_music_on && seton )
    resume_song();
    sfx_music_on = seton;
    sfx_music( sfx_song_playing );
  end;
  sfx_music_on = seton;
end

/*-------------------------------------------------------------------------*/

function sfx_music_theme( int scheme )
begin
  switch( scheme )
    case 1:
      say('THEME: '+sfx_music_schemes[scheme] );
      sfx_music_scheme = scheme;
      sfx_song_files = &sfx_song_files1;
      sfx_music_on(1);
      sfx_music( sfx_song_playing );
    end
    case 2:
      say('THEME: '+sfx_music_schemes[scheme] );
      sfx_music_scheme = scheme;
      sfx_song_files = &sfx_song_files2;
      sfx_music_on(1);
      sfx_music( sfx_song_playing );
    end
    default:
      say('THEME: '+sfx_music_schemes[0] );
      sfx_song_files = &sfx_song_files1;
      sfx_music_scheme = 0;
      sfx_music_on(0);
    end;
  end
end

/*-------------------------------------------------------------------------*/

function sfx_change_volume( int delta )
begin
  sfx_sound_volume += delta;
  if( sfx_sound_volume < 0 ) sfx_sound_volume= 0; end
  if( sfx_sound_volume > 128 ) sfx_sound_volume = 128; end
  
  set_song_volume( sfx_sound_volume * 3 / 4 );
    
  set_wav_volume ( sfx_metal_bell , sfx_sound_volume ); 
  set_wav_volume ( sfx_metal_collision , sfx_sound_volume ); 
  set_wav_volume ( sfx_ribbon_collision , sfx_sound_volume ); 
  set_wav_volume ( sfx_scream , sfx_sound_volume ); 
  set_wav_volume ( sfx_metal_don , sfx_sound_volume ); 
  set_wav_volume ( sfx_brick_collision , sfx_sound_volume ); 
end

/*-------------------------------------------------------------------------*/
